package com.cf.imes.module.executor.service.order;

import com.alibaba.fastjson.JSONObject;
import com.cf.imes.framework.common.pojo.PageParam;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.executor.controller.admin.order.vo.order.*;
import com.cf.imes.module.executor.controller.admin.order.vo.product.OrderBodyRespVO;
import com.cf.imes.module.executor.controller.admin.order.vo.product.OrderRoomBodyRespVO;
import com.cf.imes.module.executor.controller.admin.orderParts.vo.OrderPartsRespVO;
import com.cf.imes.module.executor.dal.dataobject.order.OrderDO;
import com.cf.imes.module.executor.util.fileConversion.admin.api.webcad.ApiDataTypeVo;
import org.springframework.boot.system.ApplicationHome;
import org.springframework.web.multipart.MultipartFile;

import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import java.io.File;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 生产单表 order_{N} Service 接口
 *
 * @author 晨丰科技
 */
public interface OrderService {

    /**
     * 创建生产单表 order_{N}
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOrder(@Valid OrderSaveReqVO createReqVO);

    /**
     * 更新生产单表 order_{N}
     *
     * @param updateReqVO 更新信息
     */
    void updateOrder(@Valid OrderSaveReqVO updateReqVO);

    /**
     * 获得生产单表 order_{N}
     *
     * @param id 编号
     * @return 生产单表 order_{N}
     */
    OrderDO getOrder(Long id);

    /**
     * 获得生产单表 order_{N}分页
     *
     * @param pageReqVO 分页查询
     * @return 生产单表 order_{N}分页
     */
    PageResult<OrderDO> getOrderPage(OrderPageReqVO pageReqVO);

    /**
     * @param orderId: 生产单Id
     * @return List<OrderBodyRespVO>
     */
    List<OrderBodyRespVO> getOrderBody(Long orderId, Integer deleted);


    List<OrderRoomBodyRespVO> getRoomAndBody(Long planId);


    /**
     * @param orderId: 生产单Id
     * @return Map<String, Object>
     */
    Map<String, Object> getModule(Long orderId, Integer deleted);

    /**
     * @param orderId: 生产单id
     * @param roomId:  房间id
     * @param bodyId:  柜体id
     * @return List<OrderPlatesDetailReqVO>
     * 需要修改返回值
     */
    PageResult<OrderPlatesDetailReqVO> getPlatesDetail(Long orderId, Set<Long> roomId, Set<Long> bodyId, Set<Long> groupId, String groupName, Integer pageNo, Integer pageSize, Integer deleted);

    /**
     * @param orderId: 生产单id
     * @param roomId:  房间id
     * @param bodyId:  柜体id
     * @return List<OrderPartsRespVO>
     * 需要修改返回值
     */
    PageResult<OrderPartsRespVO> getPartsDetail(Long orderId, Set<Long> roomId, Set<Long> bodyId, Set<Long> groupId, String name, Integer pageNo, Integer pageSize, Integer deleted, Set<String> types);

    /**
     * @param orderId: 生产单id
     * @param roomId:  房间id
     * @param bodyId:  柜体id
     * @return List<OrderGoodsDetailRespVO>
     * 需要修改返回值
     */
    PageResult<OrderGoodsDetailRespVO> getGoodsDetail(Long orderId, Set<Long> roomId, Set<Long> bodyId, Set<Long> groupId, Set<Long> goodsId, Integer pageNo, Integer pageSize, Integer deleted);

    /**
     * 删除柜体/柜体还原
     *
     * @param orderId: 生产单id
     * @param roomId:  房间id
     * @param bodyId:  柜体id
     */
    void updateDeleteBody(Long orderId, Set<Long> roomId, Long bodyId, Integer status);

    void updateRestoreBody(Long orderId, Set<Long> roomId, Long bodyId, Integer status);

    /**
     * @param apiDataTypeVo：生产单号
     * @return Boolean
     */
    Long importApiData(ApiDataTypeVo apiDataTypeVo);

    /**
     * 文件数据导入
     */
    void importExcelData(OrderDO orderDO, Integer index, Map<String, Object> mapOrder);

    /**
     * 生产导入文件模板下载
     */
    void exportTemplate(HttpServletResponse response, String value);

    /**
     * 打印/导出数据获取 （单文件）
     */
    Map<String, Object> getPrintDataMap(Long orderId, String type, HttpServletResponse response);

    default String getSavePath() {
        ApplicationHome applicationHome = new ApplicationHome(this.getClass());

        // 保存目录位置根据项目需求可随意更改
        return applicationHome.getDir().getAbsolutePath() + File.separator + "type";

    }

    /**
     * 自定义单号是否存在
     */
    Boolean customOrderNoIsExists(String customOrderNo);

    /**
     * 查找api单号列表
     */
    List<ApiOrderRespVO> getApiOrderList(JSONObject orderList);


    /**
     * 生产单超期告警分析统计
     */
    PageResult<OrderOverdueRespVO> getOrderOverdue(PageParam pageParam);

    /**
     * 生产单到期告警分析统计
     */
    PageResult<OrderOverdueRespVO> getOrderNear(PageParam pageParam);


    /**
     * 修改生产单是否删除
     */
    Integer updateOrderDel(Long orderId, Integer status);


    /**
     * 作废中删除
     */
    void realDeletedOrder(Long orderId);

    /**
     * 生产单异步导入
     *
     * @param importAsyncReqVO
     */
    void orderImportAsync(OrderImportAsyncReqVO importAsyncReqVO, MultipartFile file);

    OrderAllData getOrderAllData(Long orderId, Long planId);

}